<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__optimization__config" kind="group">
    <compoundname>group_optimization_config</compoundname>
    <title>Optimization of Wi-Fi Middleware Core</title>
    <briefdescription>
<para>For PSoC 6 MCU family of chips and Wi-Fi/BT connectivity chips that have limited flash and RAM footprint, there is a need to optimize the various connectivity middleware components to fit into kits that use these chips. </para>    </briefdescription>
    <detaileddescription>
<para>Examples include CY8CPROTO-062S3-4343W that has 512KB flash and 256KB SRAM.</para><para>The default lwIP and Mbed TLS configuration files bundled with the Wi-Fi Middleware Core have serveral features enabled for typical embedded IoT use cases. However, not all of these parameters are pertinent for every use case. The approach is to provide a set of such tunables that can be turned off in order to conserve memory, thus enabling the firmware to fit into the available flash and RAM.</para><para>The lwIP parameters are defined in <ulink url="https://github.com/cypresssemiconductorco/wifi-mw-core/configs/lwipopts.h">lwipopts.h</ulink>. Modify this header file to customize the lwIP parameters defined in the table below.</para><para>For Mbed TLS, a default config.h file is bundled with the Mbed TLS library. It is not recommended to modify the default config header file; you should modify the user-defined <ulink url="https://github.com/cypresssemiconductorco/wifi-mw-core/configs/mbedtls_user_config.h">mbedtls_user_config.h</ulink> file bundled with Wi-Fi Middleware Core. The approach is to update the mbedtls_user_config.h file to override the default behavior defined in the config.h file. Note that this mbedtls_user_config.h file has been tuned with several options to conserve memory for common embedded IoT use cases from the default config.h file, amounting to approx. 16KB of code memory savings. The following recommendations are additional optimizations.</para><para>The configurations listed below provide savings to one of the following: code memory, static RAM, or heap memory. Some parameters may save code memory at the cost of heap/SRAM.</para><para>The savings are mentioned in kilobytes, and are an estimate (computed in DEBUG build). Actual values may differ from the numbers provided below.</para>
<para><heading level="1">Mbed TLS configuration parameters</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration Parameter &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Savings &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Type of memory &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Action needed &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Notes  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_SSL_SRV_C &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~16KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:Enabled.&lt;br /&gt;To disable, #undef MBEDTLS_SSL_SRV_C in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enables the SSL/TLS server code. This configuration is used when device is expected to function as an SSL/TLS server and can be disabled if only run SSL/TLS client mode is required.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_SSL_CLI_C &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~14KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:Enabled. &lt;br /&gt;To disable, #undef MBEDTLS_SSL_CLI_C in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enables the SSL/TLS client code. This configuration is used when device is expected to function as an SSL/TLS client and can be disabled if only run SSL/TLS server mode is required. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_AES_ROM_TABLES &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~8.5KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Static RAM &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:Disabled. &lt;br /&gt;To enable, #define MBEDTLS_AES_ROM_TABLES in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enable this parameter to use precomputed AES tables stored in ROM. When disabled, the AES tables are generated in RAM at runtime. It comes at the cost of additional code memory and potentially degraded performance if ROM access is slower than RAM access. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_SSL_IN_CONTENT_LEN &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~8KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Heap memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:16384. &lt;br /&gt;To override, #define MBEDTLS_SSL_IN_CONTENT_LEN 8192 in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Maximum length (in bytes) of incoming plaintext fragments. This determines the size of the incoming TLS I/O buffer in such a way that it is capable of holding the specified amount of plaintext data, regardless of the protection mechanism used. If it is known that the use case running on the device needs smaller-sized buffers (both for handshake and data), this parameter can be tuned to a lower value. The recommended value of 8192 is indicative and can be set lower/upper depending on the end use case. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_SSL_OUT_CONTENT_LEN &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~8KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Heap memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:16384. &lt;br /&gt;To override, #define MBEDTLS_SSL_OUT_CONTENT_LEN 8192 in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Maximum length (in bytes) of incoming plaintext fragments. This determines the size of the outgoing TLS I/O buffer in such a way that it is capable of holding the specified amount of plaintext data, regardless of the protection mechanism used. If it is known that the use case running on the device needs smaller-sized buffers (both for handshake and data), this parameter can be tuned to a lower value. The recommended value of 8192 is indicative and can be set lower/upper depending on the end use case. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_CHACHA20_C &lt;br /&gt; MBEDTLS_CHACHAPOLY_C &lt;br /&gt; MBEDTLS_POLY1305_C &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~4KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:Enabled. &lt;br /&gt;To disable, #undef MBEDTLS_CHACHA20_C &lt;br /&gt;#undef MBEDTLS_CHACHAPOLY_C&lt;br /&gt;#undef MBEDTLS_POLY1305_C in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;These options enable support for ChaCha20 stream cipher, ChaCha20-Poly1305 AEAD algorithm and Poly1305 MAC algorithm respectively. These are generally used for HomeKit ADK library features. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_CAMELLIA_SMALL_MEMORY &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~1KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:Disabled. &lt;br /&gt;To enable, #define MBEDTLS_CAMELLIA_SMALL_MEMORY in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This parameter is used to save code memory by using a small footprint Camellia implementation. Mutually exclusive to MBEDTLS_CAMELLIA_C below. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_CAMELLIA_C &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~7.5KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:Enabled. &lt;br /&gt;To enable, #define MBEDTLS_CAMELLIA_C in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This parameter enables support for the fully featured Camellia cipher suites. Mutually exclusive to MBEDTLS_CAMELLIA_SMALL_MEMORY above. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBEDTLS_SHA256_SMALLER &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~1.6KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:Disabled. &lt;br /&gt;To enable, #define MBEDTLS_SHA256_SMALLER in mbedtls_user_config.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enabling this option saves code space but at the expense of performance. For example, on Cortex-M4 it reduces the size by approx 2KB for a performance hit of about 30%. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">lwIP configuration parameters</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration Parameter &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Savings &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Type of memory &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Action needed &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Notes &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;LWIP_IPV6 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~27KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code memory &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;Default:Enabled. &lt;br /&gt;To disable, #define LWIP_IPV6 0 in lwipopts.h &lt;/p&gt;&lt;/td rowspan="2"&gt;&lt;td&gt;&lt;p&gt;This parameter enables support for IPv6.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;~3.3KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Static RAM &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;LWIP_STATS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;~1.4KB &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code memory &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Default:Disabled. &lt;br /&gt;To enable, #define LWIP_STATS 1 in lwipopts.h &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enabling this parameter, results in lwIP collecting debug and other statistic info. Enabled by default in DEBUG mode and disabled in RELEASE mode.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>